﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Threading;
using System.Windows.Media.Imaging;
using Microsoft.Phone.Shell;

namespace WmDevProgrammaticallyScrollListBox
{
    public partial class MainPage : PhoneApplicationPage
    {
        public List<SampleData> SimpleItems { get; set; }
        private DispatcherTimer timer = null;
        private bool isStart = false;
        private int index = 0;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromMilliseconds(1500); //delayed for 1.5 seconds
            timer.Tick += new EventHandler(timer_Tick);

            SimpleItems = new List<SampleData>() 
			{ 
			new SampleData(){Name = "User1:", ImagePath="/Images/user.png", Group ="wiki"},
			new SampleData(){Name = "User2:", ImagePath="/Images/user.png", Group="froum"},
			new SampleData(){Name = "User3:", ImagePath="/Images/user.png", Group ="nokia"},
			new SampleData(){Name = "User4:", ImagePath="/Images/user.png", Group ="dig"},
			new SampleData(){Name = "User5:", ImagePath="/Images/user.png", Group ="mirosoft"},
			new SampleData(){Name = "User6:", ImagePath="/Images/user.png", Group ="facebook"},
            new SampleData(){Name = "User7:", ImagePath="/Images/user.png", Group ="wiki"},
			new SampleData(){Name = "User8:", ImagePath="/Images/user.png", Group="froum"},
			new SampleData(){Name = "User9:", ImagePath="/Images/user.png", Group ="nokia"},
			new SampleData(){Name = "User10:", ImagePath="/Images/user.png", Group ="dig"},
			new SampleData(){Name = "User11:", ImagePath="/Images/user.png", Group ="mirosoft"},
			new SampleData(){Name = "User12:", ImagePath="/Images/user.png", Group ="facebook"},
            new SampleData(){Name = "User13:", ImagePath="/Images/user.png", Group ="wiki"},
			new SampleData(){Name = "User14:", ImagePath="/Images/user.png", Group="froum"},
			new SampleData(){Name = "User15:", ImagePath="/Images/user.png", Group ="nokia"},
			new SampleData(){Name = "User16:", ImagePath="/Images/user.png", Group ="dig"},
			new SampleData(){Name = "User17:", ImagePath="/Images/user.png", Group ="mirosoft"},
			new SampleData(){Name = "User18:", ImagePath="/Images/user.png", Group ="facebook"},
            new SampleData(){Name = "User19:", ImagePath="/Images/user.png", Group ="wiki"},
			new SampleData(){Name = "User20:", ImagePath="/Images/user.png", Group="froum"},
			new SampleData(){Name = "User21:", ImagePath="/Images/user.png", Group ="nokia"},
			new SampleData(){Name = "User22:", ImagePath="/Images/user.png", Group ="dig"},
			new SampleData(){Name = "User23:", ImagePath="/Images/user.png", Group ="mirosoft"},
			new SampleData(){Name = "User24:", ImagePath="/Images/user.png", Group ="facebook"},
			new SampleData(){Name = "User25:", ImagePath="/Images/user.png", Group ="twitter"}

			};
            this.lstSample.ItemsSource = SimpleItems;
        }



        private void DoScroll(object sender, EventArgs e)
        {
            StartScrolling();
        }

        private void changeIcon()
        {
            ApplicationBarIconButton btn = (ApplicationBarIconButton)ApplicationBar.Buttons[0];

            if (btn.Text == "play")
            {
                btn.Text = "pause";
                btn.IconUri = new Uri("/Images/pause.png", UriKind.Relative);
            }
            else if (btn.Text == "pause")
            {
                btn.Text = "play";
                btn.IconUri = new Uri("/Images/play.png", UriKind.Relative);
            }
        }

        void StartScrolling()
        {
            if (!isStart)
            {
                timer.Start();
                isStart = !isStart;
            }
            else
            {
                isStart = !isStart;
                timer.Stop();
            }
            changeIcon();
        }

        void timer_Tick(object sender, EventArgs e)
        {
            lstSample.ScrollIntoView(lstSample.Items[index]); //scroll to the current item
            lstSample.SelectedIndex = index; //highlight the selected item in the list box scroller
            SampleData item = (SampleData)lstSample.Items[index]; // getting the current item

            if (index < lstSample.Items.Count - 1)
            {
                index++;
            }
            else
            {
                lstSample.ScrollIntoView(lstSample.Items[0]); //scroll to the first item
                index = 0; //reset the index when it reaches to the last item
            }
        }
    }

    public class SampleData
    {
        public string ImagePath { get; set; }
        public string Name { get; set; }
        public string Group { get; set; }
    }
}